clear;clc;
addpath .\fdtd_sw
addpath .\fdtd_sw\GF_sw
load('conf1');
n_pool=input('Input the number of CPU cores you want to use : ');
fdtd_sw(mdl,[0;0;0],[8;8;8],exc,out,sw,1000,20,n_pool);
%
Rs=1;
BW=150e6;
A=1e-6;
d=[0;0;1];
X0=[1;-1;0];
delta=0.05;
%
c=299792458;
sgm=0.483/BW;
cdt=delta/sqrt(3);
cT=c*16*sgm;
L=delta*d;
Xn=X0-L/2;
Xp=X0+L/2;
%
X =[1.25;0;0.025];
[E1,ct1]=dipole_sw(Rs,Xp,Xn,X,A,BW,cdt,cT);
E0max=max(abs(E1(3,:)));
X =[1.4;0;0.025];
[E2,ct2]=dipole_sw(Rs,Xp,Xn,X,A,BW,cdt,cT);
X =[1.25;0.15;0.025];
[E3,ct3]=dipole_sw(Rs,Xp,Xn,X,A,BW,cdt,cT);
save('dipole_GFM','E1','ct1','E2','ct2','E3','ct3');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
vt1=load('vt1.txt');
figure;hold on;
plot(vt1(:,1),-vt1(:,2)/delta);
plot(ct1+(0:size(E1,2)-1)*cdt,E1(3,:),'r:');
title('Pt1');
legend('FDTD','GFM');
%
vt2=load('vt2.txt');
figure;hold on;
plot(vt2(:,1),-vt2(:,2)/delta);
plot(ct2+(0:size(E2,2)-1)*cdt,E2(3,:),'r:');
title('Pt2');
legend('FDTD','GFM');
%
vt3=load('vt3.txt');
figure;hold on;
plot(vt3(:,1),-vt3(:,2)/delta);
plot(ct3+(0:size(E3,2)-1)*cdt,E3(3,:),'r:');
title('Pt3');
legend('FDTD','GFM');
%
figure;hold on;
vs1=load('vs1.txt');
vs2=load('vs2.txt');
plot(vs1(:,1),20*log10(abs(vs1(:,2)/delta)/E0max));
plot(vs2(:,1),20*log10(abs(vs2(:,2)/delta)/E0max),'r:');