function [lamda,x]=geodesic_sw_bvp(null,d_ref,Rs,r0,r1,phi0,phi1,ct0,ct1)
% ct  = x(1,:)
% r   = x(2,:)
% phi = x(3,:)
% ct' = x(4,:)
% r'  = x(5,:)
% phi'= x(6,:)
if(null)
    ct1=ct0+1;
    %L=sqrt((r0^2+r1^2-2*r0*r1*cos(phi1-phi0))/(1-Rs/min(r0,r1)));
    L=sqrt(max(1./(1-Rs./[r0,r1]))*(r0-r1)^2+max([r0,r1])^2*(phi0-phi1)^2);
else
    L=(ct1-ct0)*sqrt(1-Rs/max(r0,r1));
end
N=ceil(L/d_ref);
%%%%
b0=[ct0;r0;phi0];
b1=[ct1;r1;phi1];
x=bvp5c(@(lamda,x) equ_geodesic_sw(lamda,x,Rs),...
    @(x0,x1) bc_geodesic(x0,x1,null,Rs,b0,b1),...
    bvpinit(0:1/(N-1):1,@(lamda) xinit(lamda,b0,b1)));
lamda=x.x;
x=x.y;
end
%
function dx=equ_geodesic_sw(lamda,x,Rs)
C=Christoffel_sw(Rs,x(2),pi/2);
dx=[x(4:6);...
    -2*C(1,1,2)*x(4)*x(5);...
    -C(2,1,1)*x(4)^2-C(2,2,2)*x(5)^2-C(2,4,4)*x(6)^2;...
    -2*C(4,2,4)*x(5)*x(6)];
end
%
function res=bc_geodesic(x0,x1,null,Rs,b0,b1)
res=[x0(1:3)-b0;x1(1:3)-b1];
if(null)
    g=metric_sw(Rs,b0(2),pi/2);
    res(4)=g(1,1)*x0(4)^2+g(2,2)*x0(5)^2+g(4,4)*x0(6)^2;
end
end
%
function x0=xinit(lamda,b0,b1)
x0=[b0+(b1-b0)*lamda;b1-b0];
end