function far=far_init(mdl,far,sw,n_pool)
disp('Calc Green Function for far field ...');
% ch=input('Read from file (Y or N) ? ','s');
ch='N';
if(ch=='Y'||ch=='y')
load('far');
else
%%%%%%
far=far_alloc(mdl,far);
if(size(far.xf,1)~=3)
    far.xf=far.xf.';
end
nx=mdl.Nox;
ny=mdl.Noy;
nz=mdl.Noz;
dx0=mdl.dx0;
x=(mdl.x(mdl.Io(1):mdl.Io(2)-1)+mdl.x(mdl.Io(1)+1:mdl.Io(2)))/2;
y=(mdl.y(mdl.Jo(1):mdl.Jo(2)-1)+mdl.y(mdl.Jo(1)+1:mdl.Jo(2)))/2;
z=(mdl.z(mdl.Ko(1):mdl.Ko(2)-1)+mdl.z(mdl.Ko(1)+1:mdl.Ko(2)))/2;
%disp('Calc Green Function for far field ...');
%
% if(sw.Rs~=0)
myCluster=parcluster();
myCluster.NumWorkers=n_pool;
pool=parpool(myCluster);
% end
%
for s=1:2
    xo=mdl.x(mdl.Io(s));
    yo=mdl.y(mdl.Jo(s));
    zo=mdl.z(mdl.Ko(s));
    for nf=1:far.nf
        Xf=far.xf(:,nf);
%%%%%%%%%%%%%  X  %%%%%
        N=ny*nz;
        ct=zeros(  1,N);
        A =zeros(3,4,N);
        B =zeros(3,4,N);
        C =zeros(3,4,N);
        D =zeros(3,4,N);
        ch=[num2str(1+3*(nf-1)+3*far.nf*(s-1)),'/',num2str(6*far.nf)];
        parfor n=1:N
            disp([ch,', ',num2str(n),'/',num2str(N),'...']);
            [j,k]=ind2sub([ny,nz],n);
            X0=sw.X0+[xo;y(j);z(k)]; % 
            [ct(n),A(:,:,n),B(:,:,n),C(:,:,n),D(:,:,n)]=...
                matrix_dE(X0,Xf,sw.Rs,dx0); %
        end
        far.ct{s,1}(:,:,nf)=reshape(ct,ny,nz);
        far.A {s,1}(:,:,:,:,nf)=reshape(shiftdim(A,2),ny,nz,3,4);
        far.B {s,1}(:,:,:,:,nf)=reshape(shiftdim(B,2),ny,nz,3,4);
        far.C {s,1}(:,:,:,:,nf)=reshape(shiftdim(C,2),ny,nz,3,4);
        far.D {s,1}(:,:,:,:,nf)=reshape(shiftdim(D,2),ny,nz,3,4);
%%%%%%%%%%%%  Y  %%%%%
        N=nx*nz;
        ct=zeros(  1,N);
        A =zeros(3,4,N);
        B =zeros(3,4,N);
        C =zeros(3,4,N);
        D =zeros(3,4,N);
        ch=[num2str(2+3*(nf-1)+3*far.nf*(s-1)),'/',num2str(6*far.nf)];
        parfor n=1:N
            disp([ch,', ',num2str(n),'/',num2str(N),'...']);
            [i,k]=ind2sub([nx,nz],n);
            X0=sw.X0+[x(i);yo;z(k)];
            [ct(n),A(:,:,n),B(:,:,n),C(:,:,n),D(:,:,n)]=...
                matrix_dE(X0,Xf,sw.Rs,dx0);
        end
        far.ct{s,2}(:,:,nf)=reshape(ct,nx,nz);
        far.A {s,2}(:,:,:,:,nf)=reshape(shiftdim(A,2),nx,nz,3,4);
        far.B {s,2}(:,:,:,:,nf)=reshape(shiftdim(B,2),nx,nz,3,4);
        far.C {s,2}(:,:,:,:,nf)=reshape(shiftdim(C,2),nx,nz,3,4);
        far.D {s,2}(:,:,:,:,nf)=reshape(shiftdim(D,2),nx,nz,3,4);
%%%%%%%%%%%%%%  Z  %%%%%
        N=nx*ny;
        ct=zeros(  1,N);
        A =zeros(3,4,N);
        B =zeros(3,4,N);
        C =zeros(3,4,N);
        D =zeros(3,4,N);
        ch=[num2str(3+3*(nf-1)+3*far.nf*(s-1)),'/',num2str(6*far.nf)];
        parfor n=1:N
            disp([ch,', ',num2str(n),'/',num2str(N),'...']);
            [i,j]=ind2sub([nx,ny],n);
            X0=sw.X0+[x(i);y(j);zo];
            [ct(n),A(:,:,n),B(:,:,n),C(:,:,n),D(:,:,n)]=...
                matrix_dE(X0,Xf,sw.Rs,dx0);
        end
        far.ct{s,3}(:,:,nf)=reshape(ct,nx,ny);
        far.A {s,3}(:,:,:,:,nf)=reshape(shiftdim(A,2),nx,ny,3,4);
        far.B {s,3}(:,:,:,:,nf)=reshape(shiftdim(B,2),nx,ny,3,4);
        far.C {s,3}(:,:,:,:,nf)=reshape(shiftdim(C,2),nx,ny,3,4);
        far.D {s,3}(:,:,:,:,nf)=reshape(shiftdim(D,2),nx,ny,3,4);
    end
end
% if(sw.Rs~=0)
delete(pool);
% end
clear ct A B C D;
save('far','far');
end
disp('Calc Green Function for far field End.');
%
far.ct0=inf*ones(far.nf,1);
far.L=zeros(far.nf,1);
for nf=1:far.nf
    for p=1:3
        for s=1:2
            far.ct0(nf)=min(far.ct0(nf),min(min(far.ct{s,p}(:,:,nf))));
            far.L(nf)  =max(far.L(nf)  ,max(max(far.ct{s,p}(:,:,nf))));
        end
    end
end
far.L=ceil((far.L-far.ct0)/mdl.dx0)+5;
%
far.Lc=  ones(far.nf,1); 
far.Lo=2*ones(far.nf,1); 
far.Ls=3*ones(far.nf,1); 
%
far.E=cell(3,far.nf);
for nf=1:far.nf
    for i=1:3
        far.E{nf}=zeros(far.L(nf),3);
    end
    for p=1:3
        for s=1:2
            far.ct{s,p}(:,:,nf)=(far.ct{s,p}(:,:,nf)-far.ct0(nf))/mdl.dx0;
        end
    end
end
%
far.n1=1;
far.n2=2;
%
far.ax=(mdl.x(mdl.Io+1)-mdl.x(mdl.Io))./(mdl.x(mdl.Io+1)-mdl.x(mdl.Io-1));
far.ay=(mdl.y(mdl.Jo+1)-mdl.y(mdl.Jo))./(mdl.y(mdl.Jo+1)-mdl.y(mdl.Jo-1));
far.az=(mdl.z(mdl.Ko+1)-mdl.z(mdl.Ko))./(mdl.z(mdl.Ko+1)-mdl.z(mdl.Ko-1));
%
far.No1=[mdl.Noy,mdl.Nox,mdl.Nox];
far.No2=[mdl.Noz,mdl.Noz,mdl.Noy];
%
far.calcJm={@far_Jm_x,@far_Jm_y,@far_Jm_z};
far.calcZJ={@far_ZJ_x,@far_ZJ_y,@far_ZJ_z};
%
far.Area=cell(1,3);
A=(mdl.y(mdl.Jo(1)+1:mdl.Jo(2))-mdl.y(mdl.Jo(1):mdl.Jo(2)-1))*...
  (mdl.z(mdl.Ko(1)+1:mdl.Ko(2))-mdl.z(mdl.Ko(1):mdl.Ko(2)-1)).';
far.Area{1}=A(:);
A=(mdl.x(mdl.Io(1)+1:mdl.Io(2))-mdl.x(mdl.Io(1):mdl.Io(2)-1))*...
  (mdl.z(mdl.Ko(1)+1:mdl.Ko(2))-mdl.z(mdl.Ko(1):mdl.Ko(2)-1)).';
far.Area{2}=A(:);
A=(mdl.x(mdl.Io(1)+1:mdl.Io(2))-mdl.x(mdl.Io(1):mdl.Io(2)-1))*...
  (mdl.y(mdl.Jo(1)+1:mdl.Jo(2))-mdl.y(mdl.Jo(1):mdl.Jo(2)-1)).';
far.Area{3}=A(:);
end