function [mdl,exc,out,v]=init(mdl,L_OBi,L_OBo,exc,out,sw,n_pool)
if(mdl.Nmedium==0)
    mdl.Nmedium=1;
    mdl.epsr=1;
    mdl.mur=1;
else
    mdl.Nmedium=mdl.Nmedium+1;
    mdl.epsr=[1;mdl.epsr(:)];
    mdl.mur=[1;mdl.mur(:)];
end
% dx=diff(mdl.x);
% dy=diff(mdl.y);
% dz=diff(mdl.z);
mdl.dx0=1/sqrt(1/min(diff(mdl.x))^2+1/min(diff(mdl.y))^2+1/min(diff(mdl.z))^2);  % =c*dt
mdl.dt=mdl.dx0/299792458;
mdl.ct0=0; % 
mdl.t0=0;
mdl.Ce=mdl.dx0./mdl.epsr;
mdl.Ch=mdl.dx0./mdl.mur;
%
mdl=bound_init(mdl,L_OBi,L_OBo);
mdl=grid_init(mdl);
mdl=ind_init(mdl);
v  =pml_init_sw(mdl,sw);
[mdl,exc]=exc_init(mdl,exc,sw,n_pool);
out=out_init(mdl,out,sw,n_pool);
%
nx=mdl.NX;ny=mdl.NY;nz=mdl.NZ;
mdl.iiy=nx;
mdl.iiz=nx*ny;
%
v.Ex =zeros(nx,ny,nz); % x0+(i-0.5)dx,  y0+(j-1)dy,  z0+(k-1)dz
v.Ey =zeros(nx,ny,nz); %   x0+(i-1)dx,y0+(j-0.5)dy,  z0+(k-1)dz
v.Ez =zeros(nx,ny,nz); %   x0+(i-1)dx,  y0+(j-1)dy,z0+(k-0.5)dz
v.ZHx=zeros(nx,ny,nz); %   x0+(i-1)dx,y0+(j-0.5)dy,z0+(k-0.5)dz
v.ZHy=zeros(nx,ny,nz); % x0+(i-0.5)dx,  y0+(j-1)dy,z0+(k-0.5)dz
v.ZHz=zeros(nx,ny,nz); % x0+(i-0.5)dx,y0+(j-0.5)dy,  z0+(k-1)dz
end