function [mdl,iw]=iw_init(mdl,iw,sw,n_pool)
c=299792458;
disp('Calc Green Function for incident wave ...');
% ch=input('Read from file (Y or N) ? ','s');
ch='N';
if(ch=='Y'||ch=='y')
load('iw');
else
% iw=iw_alloc(mdl,iw);
nx=mdl.Ncx;
ny=mdl.Ncy;
nz=mdl.Ncz;
dx0=mdl.dx0;
Xs=iw.x;
L=sqrt(3)*dx0*iw.d(:)/norm(iw.d);
x=mdl.x(mdl.Ic(1):mdl.Ic(2));
y=mdl.y(mdl.Jc(1):mdl.Jc(2));
z=mdl.z(mdl.Kc(1):mdl.Kc(2));
xh=(mdl.x(mdl.Ic(1):mdl.Ic(2)-1)+mdl.x(mdl.Ic(1)+1:mdl.Ic(2)))/2;
yh=(mdl.y(mdl.Jc(1):mdl.Jc(2)-1)+mdl.y(mdl.Jc(1)+1:mdl.Jc(2)))/2;
zh=(mdl.z(mdl.Kc(1):mdl.Kc(2)-1)+mdl.z(mdl.Kc(1)+1:mdl.Kc(2)))/2;
%
iw.ct_Ex =cell(2,3);
iw.ct_Ey =cell(2,3);
iw.ct_Ez =cell(2,3);
iw.ct_ZHx=cell(2,3);
iw.ct_ZHy=cell(2,3);
iw.ct_ZHz=cell(2,3);
iw.v_Ex  =cell(2,3);
iw.v_Ey  =cell(2,3);
iw.v_Ez  =cell(2,3);
iw.v_ZHx =cell(2,3);
iw.v_ZHy =cell(2,3);
iw.v_ZHz =cell(2,3);
%
% if(sw.Rs~=0)
myCluster=parcluster();
myCluster.NumWorkers=n_pool;
pool=parpool(myCluster);
% end
%
for s=1:2
    xc=mdl.x(mdl.Ic(s));
    dx=(mdl.x(mdl.Ic(s)+1)-mdl.x(mdl.Ic(s)-1))/2;
    xc1=(xc+mdl.x(mdl.Ic(s)+(-1)^s))/2;
    dx1=abs(xc-mdl.x(mdl.Ic(s)+(-1)^s));
    %
    yc=mdl.y(mdl.Jc(s));
    dy=(mdl.y(mdl.Jc(s)+1)-mdl.y(mdl.Jc(s)-1))/2;
    yc1=(yc+mdl.y(mdl.Jc(s)+(-1)^s))/2;
    dy1=abs(yc-mdl.y(mdl.Jc(s)+(-1)^s));
    %
    zc=mdl.z(mdl.Kc(s));
    dz=(mdl.z(mdl.Kc(s)+1)-mdl.z(mdl.Kc(s)-1))/2;
    zc1=(zc+mdl.z(mdl.Kc(s)+(-1)^s))/2;
    dz1=abs(zc-mdl.z(mdl.Kc(s)+(-1)^s));
%%%%%%%%%%%%%%%% x plane:  Ey Hz
    N=(ny-1)*nz;
    ct_e1=zeros(N,1);ct_e2=zeros(N,1);ct_e3=zeros(N,1);
    v_e11=zeros(N,1);v_e12=zeros(N,1);v_e13=zeros(N,1);
    v_e21=zeros(N,1);v_e22=zeros(N,1);v_e23=zeros(N,1);
    ct_h1=zeros(N,1);ct_h2=zeros(N,1);ct_h3=zeros(N,1);
    v_h11=zeros(N,1);v_h12=zeros(N,1);v_h13=zeros(N,1);
    v_h21=zeros(N,1);v_h22=zeros(N,1);v_h23=zeros(N,1);
    ch=[num2str(6*s-5),'/12'];
    parfor n=1:N
        disp([ch,', ',num2str(n),'/',num2str(N),'...']);
        [j,k]=ind2sub([ny-1,nz],n);
        %
        X=sw.X0+[xc;yh(j);z(k)];
        r=dx0/(epsrmur_sw(xc1,yh(j),z(k),sw)*dx1);
        [ct_e1(n),A,B]=matrix_dE(Xs-L/2,X,sw.Rs,dx0);
         v_e11(n)=-A(2,1)    *r*c;
         v_e21(n)=-B(2,1)    *r;
        [ct_e2(n),A,B]=matrix_dE(Xs+L/2,X,sw.Rs,dx0);
         v_e12(n)= A(2,1)    *r*c;
         v_e22(n)= B(2,1)    *r;
        [ct_e3(n),A,B]=matrix_dE(Xs,    X,sw.Rs,dx0);
         v_e13(n)= A(2,2:4)*L*r;
         v_e23(n)= B(2,2:4)*L*r/c;
        %
        X=sw.X0+[xc1;yh(j);z(k)];
        r=dx0/(epsrmur_sw(xc,yh(j),z(k),sw)*dx);
        [ct_h1(n),~,~,C,D]=matrix_dE(Xs-L/2,X,sw.Rs,dx0);
         v_h11(n)=-C(3,1)    *r*c;
         v_h21(n)=-D(3,1)    *r;
        [ct_h2(n),~,~,C,D]=matrix_dE(Xs+L/2,X,sw.Rs,dx0);
         v_h12(n)= C(3,1)    *r*c;
         v_h22(n)= D(3,1)    *r;
        [ct_h3(n),~,~,C,D]=matrix_dE(Xs,    X,sw.Rs,dx0);
         v_h13(n)= C(3,2:4)*L*r;
         v_h23(n)= D(3,2:4)*L*r/c;
    end
     iw.ct_Ey{s,1}(:,:,  1)=reshape(ct_e1,ny-1,nz);
     iw.ct_Ey{s,1}(:,:,  2)=reshape(ct_e2,ny-1,nz);
     iw.ct_Ey{s,1}(:,:,  3)=reshape(ct_e3,ny-1,nz);
      iw.v_Ey{s,1}(:,:,1,1)=reshape(v_e11,ny-1,nz);
      iw.v_Ey{s,1}(:,:,2,1)=reshape(v_e21,ny-1,nz);
      iw.v_Ey{s,1}(:,:,1,2)=reshape(v_e12,ny-1,nz);
      iw.v_Ey{s,1}(:,:,2,2)=reshape(v_e22,ny-1,nz);
      iw.v_Ey{s,1}(:,:,1,3)=reshape(v_e13,ny-1,nz);
      iw.v_Ey{s,1}(:,:,2,3)=reshape(v_e23,ny-1,nz);
    iw.ct_ZHz{s,1}(:,:,  1)=reshape(ct_h1,ny-1,nz);
    iw.ct_ZHz{s,1}(:,:,  2)=reshape(ct_h2,ny-1,nz);
    iw.ct_ZHz{s,1}(:,:,  3)=reshape(ct_h3,ny-1,nz);
     iw.v_ZHz{s,1}(:,:,1,1)=reshape(v_h11,ny-1,nz);
     iw.v_ZHz{s,1}(:,:,2,1)=reshape(v_h21,ny-1,nz);
     iw.v_ZHz{s,1}(:,:,1,2)=reshape(v_h12,ny-1,nz);
     iw.v_ZHz{s,1}(:,:,2,2)=reshape(v_h22,ny-1,nz);
     iw.v_ZHz{s,1}(:,:,1,3)=reshape(v_h13,ny-1,nz);
     iw.v_ZHz{s,1}(:,:,2,3)=reshape(v_h23,ny-1,nz);
    %
%%%%%%%%%%%%%%%% x plane:  Ez Hy
    N=ny*(nz-1);
    ct_e1=zeros(N,1);ct_e2=zeros(N,1);ct_e3=zeros(N,1);
    v_e11=zeros(N,1);v_e12=zeros(N,1);v_e13=zeros(N,1);
    v_e21=zeros(N,1);v_e22=zeros(N,1);v_e23=zeros(N,1);
    ct_h1=zeros(N,1);ct_h2=zeros(N,1);ct_h3=zeros(N,1);
    v_h11=zeros(N,1);v_h12=zeros(N,1);v_h13=zeros(N,1);
    v_h21=zeros(N,1);v_h22=zeros(N,1);v_h23=zeros(N,1);
    ch=[num2str(6*s-4),'/12'];
    parfor n=1:N
        disp([ch,', ',num2str(n),'/',num2str(N),'...']);
        [j,k]=ind2sub([ny,nz-1],n);
        %
        X=sw.X0+[xc;y(j);zh(k)];
        r=dx0/(epsrmur_sw(xc1,y(j),zh(k),sw)*dx1);
        [ct_e1(n),A,B]=matrix_dE(Xs-L/2,X,sw.Rs,dx0);
         v_e11(n)=-A(3,1)    *r*c;
         v_e21(n)=-B(3,1)    *r;
        [ct_e2(n),A,B]=matrix_dE(Xs+L/2,X,sw.Rs,dx0);
         v_e12(n)= A(3,1)    *r*c;
         v_e22(n)= B(3,1)    *r;
        [ct_e3(n),A,B]=matrix_dE(Xs,    X,sw.Rs,dx0);
         v_e13(n)= A(3,2:4)*L*r;
         v_e23(n)= B(3,2:4)*L*r/c;
        %
        X=sw.X0+[xc1;y(j);zh(k)];
        r=dx0/(epsrmur_sw(xc,y(j),zh(k),sw)*dx);
        [ct_h1(n),~,~,C,D]=matrix_dE(Xs-L/2,X,sw.Rs,dx0);
         v_h11(n)=-C(2,1)    *r*c;
         v_h21(n)=-D(2,1)    *r;
        [ct_h2(n),~,~,C,D]=matrix_dE(Xs+L/2,X,sw.Rs,dx0);
         v_h12(n)= C(2,1)    *r*c;
         v_h22(n)= D(2,1)    *r;
        [ct_h3(n),~,~,C,D]=matrix_dE(Xs,    X,sw.Rs,dx0);
         v_h13(n)= C(2,2:4)*L*r;
         v_h23(n)= D(2,2:4)*L*r/c;
    end    
     iw.ct_Ez{s,1}(:,:,  1)=reshape(ct_e1,ny,nz-1);
     iw.ct_Ez{s,1}(:,:,  2)=reshape(ct_e2,ny,nz-1);
     iw.ct_Ez{s,1}(:,:,  3)=reshape(ct_e3,ny,nz-1);
      iw.v_Ez{s,1}(:,:,1,1)=reshape(v_e11,ny,nz-1);
      iw.v_Ez{s,1}(:,:,2,1)=reshape(v_e21,ny,nz-1);
      iw.v_Ez{s,1}(:,:,1,2)=reshape(v_e12,ny,nz-1);
      iw.v_Ez{s,1}(:,:,2,2)=reshape(v_e22,ny,nz-1);
      iw.v_Ez{s,1}(:,:,1,3)=reshape(v_e13,ny,nz-1);
      iw.v_Ez{s,1}(:,:,2,3)=reshape(v_e23,ny,nz-1);
    iw.ct_ZHy{s,1}(:,:,  1)=reshape(ct_h1,ny,nz-1);
    iw.ct_ZHy{s,1}(:,:,  2)=reshape(ct_h2,ny,nz-1);
    iw.ct_ZHy{s,1}(:,:,  3)=reshape(ct_h3,ny,nz-1);
     iw.v_ZHy{s,1}(:,:,1,1)=reshape(v_h11,ny,nz-1);
     iw.v_ZHy{s,1}(:,:,2,1)=reshape(v_h21,ny,nz-1);
     iw.v_ZHy{s,1}(:,:,1,2)=reshape(v_h12,ny,nz-1);
     iw.v_ZHy{s,1}(:,:,2,2)=reshape(v_h22,ny,nz-1);
     iw.v_ZHy{s,1}(:,:,1,3)=reshape(v_h13,ny,nz-1);
     iw.v_ZHy{s,1}(:,:,2,3)=reshape(v_h23,ny,nz-1);
%%%%%%%%%%%%%%%% y plane: Ex Hz
    N=(nx-1)*nz;
    ct_e1=zeros(N,1);ct_e2=zeros(N,1);ct_e3=zeros(N,1);
    v_e11=zeros(N,1);v_e12=zeros(N,1);v_e13=zeros(N,1);
    v_e21=zeros(N,1);v_e22=zeros(N,1);v_e23=zeros(N,1);
    ct_h1=zeros(N,1);ct_h2=zeros(N,1);ct_h3=zeros(N,1);
    v_h11=zeros(N,1);v_h12=zeros(N,1);v_h13=zeros(N,1);
    v_h21=zeros(N,1);v_h22=zeros(N,1);v_h23=zeros(N,1);
    ch=[num2str(6*s-3),'/12'];
    parfor n=1:N       
        disp([ch,', ',num2str(n),'/',num2str(N),'...']);
        [i,k]=ind2sub([nx-1,nz],n);
        %
        X=sw.X0+[xh(i);yc;z(k)];
        r=dx0/(epsrmur_sw(xh(i),yc1,z(k),sw)*dy1);
        [ct_e1(n),A,B]=matrix_dE(Xs-L/2,X,sw.Rs,dx0);
         v_e11(n)=-A(1,1)    *r*c;
         v_e21(n)=-B(1,1)    *r;
        [ct_e2(n),A,B]=matrix_dE(Xs+L/2,X,sw.Rs,dx0);
         v_e12(n)= A(1,1)    *r*c;
         v_e22(n)= B(1,1)    *r;
        [ct_e3(n),A,B]=matrix_dE(Xs,    X,sw.Rs,dx0);
         v_e13(n)= A(1,2:4)*L*r;
         v_e23(n)= B(1,2:4)*L*r/c;
        %
        X=sw.X0+[xh(i);yc1;z(k)];
        r=dx0/(epsrmur_sw(xh(i),yc,z(k),sw)*dy);
        [ct_h1(n),~,~,C,D]=matrix_dE(Xs-L/2,X,sw.Rs,dx0);
         v_h11(n)=-C(3,1)    *r*c;
         v_h21(n)=-D(3,1)    *r;
        [ct_h2(n),~,~,C,D]=matrix_dE(Xs+L/2,X,sw.Rs,dx0);
         v_h12(n)= C(3,1)    *r*c;
         v_h22(n)= D(3,1)    *r;
        [ct_h3(n),~,~,C,D]=matrix_dE(Xs,    X,sw.Rs,dx0);
         v_h13(n)= C(3,2:4)*L*r;
         v_h23(n)= D(3,2:4)*L*r/c;
    end
     iw.ct_Ex{s,2}(:,:,  1)=reshape(ct_e1,nx-1,nz);
     iw.ct_Ex{s,2}(:,:,  2)=reshape(ct_e2,nx-1,nz);
     iw.ct_Ex{s,2}(:,:,  3)=reshape(ct_e3,nx-1,nz);
      iw.v_Ex{s,2}(:,:,1,1)=reshape(v_e11,nx-1,nz);
      iw.v_Ex{s,2}(:,:,2,1)=reshape(v_e21,nx-1,nz);
      iw.v_Ex{s,2}(:,:,1,2)=reshape(v_e12,nx-1,nz);
      iw.v_Ex{s,2}(:,:,2,2)=reshape(v_e22,nx-1,nz);
      iw.v_Ex{s,2}(:,:,1,3)=reshape(v_e13,nx-1,nz);
      iw.v_Ex{s,2}(:,:,2,3)=reshape(v_e23,nx-1,nz);
    iw.ct_ZHz{s,2}(:,:,  1)=reshape(ct_h1,nx-1,nz);
    iw.ct_ZHz{s,2}(:,:,  2)=reshape(ct_h2,nx-1,nz);
    iw.ct_ZHz{s,2}(:,:,  3)=reshape(ct_h3,nx-1,nz);
     iw.v_ZHz{s,2}(:,:,1,1)=reshape(v_h11,nx-1,nz);
     iw.v_ZHz{s,2}(:,:,2,1)=reshape(v_h21,nx-1,nz);
     iw.v_ZHz{s,2}(:,:,1,2)=reshape(v_h12,nx-1,nz);
     iw.v_ZHz{s,2}(:,:,2,2)=reshape(v_h22,nx-1,nz);
     iw.v_ZHz{s,2}(:,:,1,3)=reshape(v_h13,nx-1,nz);
     iw.v_ZHz{s,2}(:,:,2,3)=reshape(v_h23,nx-1,nz); 
    %
%%%%%%%%%%%%%%%% y plane: Ez Hx
    N=nx*(nz-1);
    ct_e1=zeros(N,1);ct_e2=zeros(N,1);ct_e3=zeros(N,1);
    v_e11=zeros(N,1);v_e12=zeros(N,1);v_e13=zeros(N,1);
    v_e21=zeros(N,1);v_e22=zeros(N,1);v_e23=zeros(N,1);
    ct_h1=zeros(N,1);ct_h2=zeros(N,1);ct_h3=zeros(N,1);
    v_h11=zeros(N,1);v_h12=zeros(N,1);v_h13=zeros(N,1);
    v_h21=zeros(N,1);v_h22=zeros(N,1);v_h23=zeros(N,1);
    ch=[num2str(6*s-2),'/12'];
    parfor n=1:N
        disp([ch,', ',num2str(n),'/',num2str(N),'...']);
        [i,k]=ind2sub([nx,nz-1],n);
        %
        X=sw.X0+[x(i);yc;zh(k)];
        r=dx0/(epsrmur_sw(x(i),yc1,zh(k),sw)*dy1);
        [ct_e1(n),A,B]=matrix_dE(Xs-L/2,X,sw.Rs,dx0);
         v_e11(n)=-A(3,1)    *r*c;
         v_e21(n)=-B(3,1)    *r;
        [ct_e2(n),A,B]=matrix_dE(Xs+L/2,X,sw.Rs,dx0);
         v_e12(n)= A(3,1)    *r*c;
         v_e22(n)= B(3,1)    *r;
        [ct_e3(n),A,B]=matrix_dE(Xs,    X,sw.Rs,dx0);
         v_e13(n)= A(3,2:4)*L*r;
         v_e23(n)= B(3,2:4)*L*r/c;
        %
        X=sw.X0+[x(i);yc1;zh(k)];
        r=dx0/(epsrmur_sw(x(i),yc,zh(k),sw)*dy);
        [ct_h1(n),~,~,C,D]=matrix_dE(Xs-L/2,X,sw.Rs,dx0);
         v_h11(n)=-C(1,1)    *r*c;
         v_h21(n)=-D(1,1)    *r;
        [ct_h2(n),~,~,C,D]=matrix_dE(Xs+L/2,X,sw.Rs,dx0);
         v_h12(n)= C(1,1)    *r*c;
         v_h22(n)= D(1,1)    *r;
        [ct_h3(n),~,~,C,D]=matrix_dE(Xs,    X,sw.Rs,dx0);
         v_h13(n)= C(1,2:4)*L*r;
         v_h23(n)= D(1,2:4)*L*r/c;
    end
     iw.ct_Ez{s,2}(:,:,  1)=reshape(ct_e1,nx,nz-1);
     iw.ct_Ez{s,2}(:,:,  2)=reshape(ct_e2,nx,nz-1);
     iw.ct_Ez{s,2}(:,:,  3)=reshape(ct_e3,nx,nz-1);
      iw.v_Ez{s,2}(:,:,1,1)=reshape(v_e11,nx,nz-1);
      iw.v_Ez{s,2}(:,:,2,1)=reshape(v_e21,nx,nz-1);
      iw.v_Ez{s,2}(:,:,1,2)=reshape(v_e12,nx,nz-1);
      iw.v_Ez{s,2}(:,:,2,2)=reshape(v_e22,nx,nz-1);
      iw.v_Ez{s,2}(:,:,1,3)=reshape(v_e13,nx,nz-1);
      iw.v_Ez{s,2}(:,:,2,3)=reshape(v_e23,nx,nz-1);
    iw.ct_ZHx{s,2}(:,:,  1)=reshape(ct_h1,nx,nz-1);
    iw.ct_ZHx{s,2}(:,:,  2)=reshape(ct_h2,nx,nz-1);
    iw.ct_ZHx{s,2}(:,:,  3)=reshape(ct_h3,nx,nz-1);
     iw.v_ZHx{s,2}(:,:,1,1)=reshape(v_h11,nx,nz-1);
     iw.v_ZHx{s,2}(:,:,2,1)=reshape(v_h21,nx,nz-1);
     iw.v_ZHx{s,2}(:,:,1,2)=reshape(v_h12,nx,nz-1);
     iw.v_ZHx{s,2}(:,:,2,2)=reshape(v_h22,nx,nz-1);
     iw.v_ZHx{s,2}(:,:,1,3)=reshape(v_h13,nx,nz-1);
     iw.v_ZHx{s,2}(:,:,2,3)=reshape(v_h23,nx,nz-1);
%%%%%%%%%%%%%%%% z plane: Ex Hy
    N=(nx-1)*ny;
    ct_e1=zeros(N,1);ct_e2=zeros(N,1);ct_e3=zeros(N,1);
    v_e11=zeros(N,1);v_e12=zeros(N,1);v_e13=zeros(N,1);
    v_e21=zeros(N,1);v_e22=zeros(N,1);v_e23=zeros(N,1);
    ct_h1=zeros(N,1);ct_h2=zeros(N,1);ct_h3=zeros(N,1);
    v_h11=zeros(N,1);v_h12=zeros(N,1);v_h13=zeros(N,1);
    v_h21=zeros(N,1);v_h22=zeros(N,1);v_h23=zeros(N,1);
    ch=[num2str(6*s-1),'/12'];
    parfor n=1:N
        disp([ch,', ',num2str(n),'/',num2str(N),'...']);
        [i,j]=ind2sub([nx-1,ny],n);
        %
        X=sw.X0+[xh(i);y(j);zc];
        r=dx0/(epsrmur_sw(xh(i),y(j),zc1,sw)*dz1);
        [ct_e1(n),A,B]=matrix_dE(Xs-L/2,X,sw.Rs,dx0);
         v_e11(n)=-A(1,1)    *r*c;
         v_e21(n)=-B(1,1)    *r;
        [ct_e2(n),A,B]=matrix_dE(Xs+L/2,X,sw.Rs,dx0);
         v_e12(n)= A(1,1)    *r*c;
         v_e22(n)= B(1,1)    *r;
        [ct_e3(n),A,B]=matrix_dE(Xs,    X,sw.Rs,dx0);
         v_e13(n)= A(1,2:4)*L*r;
         v_e23(n)= B(1,2:4)*L*r/c;
        %
        X=sw.X0+[xh(i);y(j);zc1];
        r=dx0/(epsrmur_sw(xh(i),y(j),zc,sw)*dz);
        [ct_h1(n),~,~,C,D]=matrix_dE(Xs-L/2,X,sw.Rs,dx0);
         v_h11(n)=-C(2,1)    *r*c;
         v_h21(n)=-D(2,1)    *r;
        [ct_h2(n),~,~,C,D]=matrix_dE(Xs+L/2,X,sw.Rs,dx0);
         v_h12(n)= C(2,1)    *r*c;
         v_h22(n)= D(2,1)    *r;
        [ct_h3(n),~,~,C,D]=matrix_dE(Xs,X,sw.Rs,dx0);
         v_h13(n)= C(2,2:4)*L*r;
         v_h23(n)= D(2,2:4)*L*r/c;
    end
     iw.ct_Ex{s,3}(:,:,  1)=reshape(ct_e1,nx-1,ny);
     iw.ct_Ex{s,3}(:,:,  2)=reshape(ct_e2,nx-1,ny);
     iw.ct_Ex{s,3}(:,:,  3)=reshape(ct_e3,nx-1,ny);
      iw.v_Ex{s,3}(:,:,1,1)=reshape(v_e11,nx-1,ny);
      iw.v_Ex{s,3}(:,:,2,1)=reshape(v_e21,nx-1,ny);
      iw.v_Ex{s,3}(:,:,1,2)=reshape(v_e12,nx-1,ny);
      iw.v_Ex{s,3}(:,:,2,2)=reshape(v_e22,nx-1,ny);
      iw.v_Ex{s,3}(:,:,1,3)=reshape(v_e13,nx-1,ny);
      iw.v_Ex{s,3}(:,:,2,3)=reshape(v_e23,nx-1,ny);
    iw.ct_ZHy{s,3}(:,:,  1)=reshape(ct_h1,nx-1,ny);
    iw.ct_ZHy{s,3}(:,:,  2)=reshape(ct_h2,nx-1,ny);
    iw.ct_ZHy{s,3}(:,:,  3)=reshape(ct_h3,nx-1,ny);
     iw.v_ZHy{s,3}(:,:,1,1)=reshape(v_h11,nx-1,ny);
     iw.v_ZHy{s,3}(:,:,2,1)=reshape(v_h21,nx-1,ny);
     iw.v_ZHy{s,3}(:,:,1,2)=reshape(v_h12,nx-1,ny);
     iw.v_ZHy{s,3}(:,:,2,2)=reshape(v_h22,nx-1,ny);
     iw.v_ZHy{s,3}(:,:,1,3)=reshape(v_h13,nx-1,ny);
     iw.v_ZHy{s,3}(:,:,2,3)=reshape(v_h23,nx-1,ny);
    %
%%%%%%%%%%%%%%%% z plane: Ey Hx
    N=nx*(ny-1);
    ct_e1=zeros(N,1);ct_e2=zeros(N,1);ct_e3=zeros(N,1);
    v_e11=zeros(N,1);v_e12=zeros(N,1);v_e13=zeros(N,1);
    v_e21=zeros(N,1);v_e22=zeros(N,1);v_e23=zeros(N,1);
    ct_h1=zeros(N,1);ct_h2=zeros(N,1);ct_h3=zeros(N,1);
    v_h11=zeros(N,1);v_h12=zeros(N,1);v_h13=zeros(N,1);
    v_h21=zeros(N,1);v_h22=zeros(N,1);v_h23=zeros(N,1);
    ch=[num2str(6*s),'/12'];
    parfor n=1:N
        disp([ch,', ',num2str(n),'/',num2str(N),'...']);
        [i,j]=ind2sub([nx,ny-1],n);
        %
        X=sw.X0+[x(i);yh(j);zc];
        r=dx0/(epsrmur_sw(x(i),yh(j),zc1,sw)*dz1);
        [ct_e1(n),A,B]=matrix_dE(Xs-L/2,X,sw.Rs,dx0);
         v_e11(n)=-A(2,1)    *r*c;
         v_e21(n)=-B(2,1)    *r;
        [ct_e2(n),A,B]=matrix_dE(Xs+L/2,X,sw.Rs,dx0);
         v_e12(n)= A(2,1)    *r*c;
         v_e22(n)= B(2,1)    *r;
        [ct_e3(n),A,B]=matrix_dE(Xs,    X,sw.Rs,dx0);
         v_e13(n)= A(2,2:4)*L*r;
         v_e23(n)= B(2,2:4)*L*r/c;
        %
        X=sw.X0+[x(i);yh(j);zc1];
        r=dx0/(epsrmur_sw(x(i),yh(j),zc,sw)*dz);
        [ct_h1(n),~,~,C,D]=matrix_dE(Xs-L/2,X,sw.Rs,dx0);
         v_h11(n)=-C(1,1)    *r*c;
         v_h21(n)=-D(1,1)    *r;
        [ct_h2(n),~,~,C,D]=matrix_dE(Xs+L/2,X,sw.Rs,dx0);
         v_h12(n)= C(1,1)    *r*c;
         v_h22(n)= D(1,1)    *r;
        [ct_h3(n),~,~,C,D]=matrix_dE(Xs,    X,sw.Rs,dx0);
         v_h13(n)= C(1,2:4)*L*r;
         v_h23(n) =D(1,2:4)*L*r/c;
    end
     iw.ct_Ey{s,3}(:,:,  1)=reshape(ct_e1,nx,ny-1);
     iw.ct_Ey{s,3}(:,:,  2)=reshape(ct_e2,nx,ny-1);
     iw.ct_Ey{s,3}(:,:,  3)=reshape(ct_e3,nx,ny-1);
      iw.v_Ey{s,3}(:,:,1,1)=reshape(v_e11,nx,ny-1);
      iw.v_Ey{s,3}(:,:,2,1)=reshape(v_e21,nx,ny-1);
      iw.v_Ey{s,3}(:,:,1,2)=reshape(v_e12,nx,ny-1);
      iw.v_Ey{s,3}(:,:,2,2)=reshape(v_e22,nx,ny-1);
      iw.v_Ey{s,3}(:,:,1,3)=reshape(v_e13,nx,ny-1);
      iw.v_Ey{s,3}(:,:,2,3)=reshape(v_e23,nx,ny-1);
    iw.ct_ZHx{s,3}(:,:,  1)=reshape(ct_h1,nx,ny-1);
    iw.ct_ZHx{s,3}(:,:,  2)=reshape(ct_h2,nx,ny-1);
    iw.ct_ZHx{s,3}(:,:,  3)=reshape(ct_h3,nx,ny-1);
     iw.v_ZHx{s,3}(:,:,1,1)=reshape(v_h11,nx,ny-1);
     iw.v_ZHx{s,3}(:,:,2,1)=reshape(v_h21,nx,ny-1);
     iw.v_ZHx{s,3}(:,:,1,2)=reshape(v_h12,nx,ny-1);
     iw.v_ZHx{s,3}(:,:,2,2)=reshape(v_h22,nx,ny-1);
     iw.v_ZHx{s,3}(:,:,1,3)=reshape(v_h13,nx,ny-1);
     iw.v_ZHx{s,3}(:,:,2,3)=reshape(v_h23,nx,ny-1);
end
% if(sw.Rs~=0)
delete(pool);
% end
clear ct_e1 ct_e2 ct_e3 v_e11 v_e21 v_e12 v_e22 v_e13 v_e23;
clear ct_h1 ct_h2 ct_h3 v_h11 v_h21 v_h12 v_h22 v_h13 v_h23;
save('iw','iw');
end
disp('Calc Green Function for incident wave End.');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
iw.sgm=0.483/iw.BW;
ct0=inf;
for p=1:3
    for s=1:2
        if(p~=1)
            ct0=min(ct0,min(min(min(iw.ct_Ex {s,p}))));
            ct0=min(ct0,min(min(min(iw.ct_ZHx{s,p}))));
        end
        if(p~=2)
            ct0=min(ct0,min(min(min(iw.ct_Ey {s,p}))));
            ct0=min(ct0,min(min(min(iw.ct_ZHy{s,p}))));
        end
        if(p~=3)
            ct0=min(ct0,min(min(min(iw.ct_Ez {s,p}))));
            ct0=min(ct0,min(min(min(iw.ct_ZHz{s,p}))));
        end
    end
end
mdl.ct0=ct0; %
mdl.t0=ct0/c;
end